Summary:        A dynamic adaptive IRQ balancing daemon
Name:           irqbalance
Version:        1.4.0
Release:        18
Epoch:          3

License:        GPLv2
Source0:        https://github.com/Irqbalance/irqbalance/archive/irqbalance-%{version}.tar.gz
Source1:        irqbalance.sysconfig
Source2:        irqbalance.rules
Source3:        irq_balancer
Url:            https://github.com/irqbalance/irqbalance

BuildRequires:  gdb autoconf automake libtool libcap-ng systemd
BuildRequires:  glib2-devel pkgconf libcap-ng-devel ncurses-devel

Requires: ncurses-libs

%ifnarch %{arm}
BuildRequires:  numactl-devel
Requires: numactl-libs
%endif

%define _hardened_build 1

Patch0: add-a-catchall-guessing-mechanis.patch
Patch1: irq_db-don-t-fail-entirely-if-we-don-t-have-a-pci-bu.patch
Patch2: cputree-adjust-snprintf-sizes-to-avoid-gcc-warnings.patch
Patch3: classify-remove-unused-label.patch
Patch4: parse_proc_interrupts-ensure-that-buffer-is-long-eno.patch
Patch5: Fix-some-string-copy-limitations.patch
Patch6: irqbalance-Add-support-for-file-based-socket-for-IPC.patch
Patch7: Fix-several-memleak-problems-found-by-covscan.patch
Patch8: Fix-an-possible-overflow-error.patch
Patch9: Fix-irqbalance-ui-failing-to-connect-to-irqbalance-d.patch
Patch10:procinterrupts-check-xen-dyn-event-more-flexible.patch
Patch11:Fix-ambiguous-parsing-of-node-entries-in-sys.patch
Patch12:Don-t-leak-socket-fd-on-connection-error.patch
Patch13:Fix-string-truncation-issues-detected-by-GCC-8.patch
Patch14:fix-balancing-when-numa-information-isn-t-available.patch

Patch6000: Checking-return-value-of-strdup-in-collect_full_irq_.patch
Patch6001: getline-clean-up-freeing-of-lines-from-getline.patch
Patch6002: free-the-memory-when-getline-fail-in-add_one_node.patch
Patch6003: prevent-NULL-pointer-dereference-when-memory-allocat.patch
Patch6004: fix-resource-leak-for-not-invoking-closedir-after-op.patch
Patch6005: correct-to-use-realloc-function.patch
Patch6006: fix-the-problem-of-banmod-that-memory-is-freed-befor.patch
Patch6007: fix-sleep-interval-when-sleep_interval-is-changed-by.patch
Patch6008: fix-resource-leak-on-the-error-paths-in-main.patch
Patch6009: fix-invalid-pointer-dereference-banned_cpumask_from_.patch
Patch6010: free-cpu_ban_string-when-the-next-request-come.patch

Patch9000: irqbalance-1.0.4-env-file-path.patch
Patch9001: bugfix-fix-a-hole-that-flees-hotplug-event.patch
Patch9002: bugfix-use-policy-prior-to-the-default-values.patch
Patch9003: bugfix-force-irq-into-rebalance-list-when-irq-removed-and-reinserted.patch
Patch9004: feature-irqbalance-aarch64-add-the-regular-to-get-th.patch
Patch9005: feature-irqbalance-arm64-Add-irq-aff-change-check.patch
Patch9006: feature-irqbalance-auto-banned-pci-assigned-irq.patch
Patch9007: bugfix-irqbalance-fix-wrong-pid-value-in-pid-file.patch
Patch9008: feature-supplement-irqbalance-service-config.patch
Patch9009: bugfix-fgets-will-get-a-redundant-new-line.patch
Patch9010: bugfix-Prevent-inserting-a-duplicate-entry-to-avoid-list-ch.patch
Patch9011: bugfix-guess_arm_irq_hints.patch
Patch9012: feature-add-new-user-irq-policy-config-rule.patch
Patch9013: bugfix-make-the-return-value-of-getline-handled-correct.patch
Patch9014: bugfix-change-irq-ban-check-path-to-devpath.patch
Patch9015: bugfix-fix-new-irqs-in-hotplug-keep-stay-on-one-numa.patch
Patch9016: feature-add-the-switch-of-printing-log.patch
Patch9017: bugfix-fix-new-msi-irq-hasnot-been-added-to-rebalance-list.patch
Patch9018: bugfix-delete-no-existing-banned-irq.patch
Patch9019: bugfix-fix-strcat-may-cause-buffer-overrun.patch
Patch9020: feature-introduce-verifyhint-to-detect-hint-variation.patch
Patch9021: bugfix-fix-memory-leak-of-strdup-in-collect_full_irq_list.patch
Patch9022: feature-add-switch-to-clear-affinity-hint.patch
Patch9023: feature-add-new-irq-migrate-rule-to-avoid-high-cpu-irq-load.patch
Patch9024: bugfix-prevent-version-cmd-need-an-argument.patch
Patch9025: feature-encapsulate-and-compile-the-functions-in-irqbalance-ui.patch
Patch9026: feature-enable-irqbalance-to-link-with-multiple-clie.patch
Patch9027: feature-irqbalance-Add-ability-for-socket-communicat.patch

%description
Irqbalance is a daemon to help balance the cpu load generated by
interrupts across all of a systems cpus. Irqbalance identifies the
highest volume interrupt sources, and isolates each of them to a
single unique cpu, so that load is spread as much as possible over
an entire processor set, while minimizing cache miss rates for irq
handlers.

%package devel
Summary: The development files of irqbalance client
Requires: glib2-devel ncurses-devel irqbalance-libs

%description devel
Development files for irqbalance client.

%package libs
Summary: The shared librariy of irqbalance client
Requires: glib2 ncurses-libs

%description libs
Shared librariy for irqbalanace client

%package_help

%prep
%autosetup -p1

%build
./autogen.sh
%configure
CFLAGS="%{optflags}" %make_build CFLAGS+='-fstack-protector-strong -fPIC'
cd ui
make
cd -

%install
install -D -p -m 0755 %{name} %{buildroot}%{_sbindir}/%{name}
install -D -p -m 0644 ./misc/%{name}.service %{buildroot}/%{_unitdir}/%{name}.service
install -D -p -m 0644 %{SOURCE1} %{buildroot}%{_sysconfdir}/sysconfig/%{name}
install -D -p -m 0755 %{SOURCE2} %{buildroot}%{_sysconfdir}/sysconfig/%{name}.rules
install -D -p -m 0755 %{SOURCE3} %{buildroot}%{_sbindir}/irq_balancer

install -D -p -m 0640 ui/irqbalance_client.h %{buildroot}%{_includedir}/irqbalance_client.h
install -D -p -m 0640 ui/libirqbalance_client.so %{buildroot}%{_libdir}/libirqbalance_client.so

install -d %{buildroot}%{_mandir}/man1/
install -p -m 0644 ./%{name}.1 %{buildroot}%{_mandir}/man1/

%check
make check

%files
%doc COPYING AUTHORS
%{_sbindir}/%{name}
%{_unitdir}/%{name}.service
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%{_sysconfdir}/sysconfig/%{name}.rules
%{_sbindir}/irq_balancer

%files devel
%{_includedir}/irqbalance_client.h

%files libs
%{_libdir}/libirqbalance_client.so

%files help
%{_mandir}/man1/*

%post
%systemd_post %{name}.service

%preun
%systemd_preun %{name}.service

%postun
%systemd_postun_with_restart %{name}.service

%triggerun -- %{name} < 2:0.56-3
if /sbin/chkconfig --level 3 %{name} ; then
    /bin/systemctl enable %{name}.service >/dev/null 2>&1 || :
fi
/sbin/chkconfig --del %{name} >/dev/null 2>&1 || :

%changelog
* Tue Mar 24 2020 Shuaishuai Song <songshuaishuai2@huawei.com> - 3:1.4.0-18
- Type:bugfix
- ID:NA
- SUG:restart
- DESC: fix no fPIC error

* Wed Mar 11 2020 yuxiangyang<yuxiangyang4@huawei.com> - 3:1.4.0-17
- Type:bugfix
- ID:NA
- SUG:restart
- DESC: fix rpmbuild error on x86_64 architecture

* Wed Mar 11 2020 liuchao<liuchao173@huawei.com> - 3:1.4.0-16
- Type:enhanced
- ID:NA
- SUG:restart
- DESC:synchronize patches

* Mon Dec 30 2019 yuxiangyang<yuxiangyang4@huawei.com> - 3:1.4.0-15
- Type:enhanced
- ID:NA
- SUG:restart
- DESC:update Huawei copyright

* Thu Dec 26 2019 caomeng<caomeng5@huawei.com> - 3:1.4.0-14
- Type:NA
- ID:NA
- SUG:restart
- DESC:rename the patch

* Fri Dec 20 2019 caomeng<caomeng5@huawei.com> - 3:1.4.0-13
- Type:NA
- ID:NA
- SUG:restart
- DESC:change the url

* Fri Dec 20 2019 liuchao<liuchao173@huawei.com> - 3:1.4.0-12
- Type:bugfix
- ID:NA
- SUG:restart
- DESC:synchronize patches

* Wed Nov 13 2019 liuchao<liuchao173@huawei.com> - 3:1.4.0-11
- Type:other
- ID:NA
- SUG:restart
- DESC:remove backport prefix of community patches

* Mon Nov 11 2019 liuchao<liuchao173@huawei.com> - 3:1.4.0-10
- Type:bugfix
- ID:NA
- SUG:restart
- DESC:add patches from community

* Fri Nov 8 2019 liuchao<liuchao173@huawei.com> - 3:1.4.0-9
- Type:bugfix
- ID:NA
- SUG:NA
- DESC: fix strcat may cause buffer overrun

* Thu Oct 17 2019 caomeng<caomeng5@huawei.com> - 3:1.4.0-8
- Type:other
- ID:NA
- SUG:NA
- DESC: add help package

* Mon Oct 14 2019 liuchao<liuchao173@huawei.com> - 3:1.4.0-7
- Type: bugfix
- ID:NA
- SUG:NA
- DESC: make the return value of getline handled correct and change irq ban check path to devpath

* Mon Sep 23 2019 hejingxian<hejingxian@huawei.com> - 3:1.4.0-6
- Type: enhancement
- ID:NA
- SUG:NA
- DESC: add avoid duplicate-entry insert, guess_arm_irq_hints and new config rule patches

* Thu Sep 12 2019 caomeng<caomeng5@huawei.com> - 3:1.4.0-5
- Type:other
- ID:NA
- SUG:NA
- DESC: fix make in parallel way

* Fri Aug 30 2019 caomeng<caomeng5@huawei.com> - 3:1.4.0-4
- Type:other
- ID:NA
- SUG:NA
- DESC: fix SP comile option

* Thu Aug 29 2019 caomeng<caomeng5@huawei.com> - 3:1.4.0-3
- Type:other
- ID:NA
- SUG:NA
- DESC: openeuler rewrite spec file

* Thu Aug 29 2019 caomeng<caomeng5@huawei.com> - 3:1.4.0-2
- Package init


